/*
 ͻ
  CDPclean:    Removes all IMMCDDiscResumePosition entries from CDP.INI     
  Written by Rob van der Woude                                              
  http://www.robvanderwoude.com                                             
  Latest revision:   2000/06/04                                             
  This program is used to remove all IMMCDDiscResumePosition entries from   
  CDP.INI, the INI file of OS/2's (MMOS2) audio CD player.                  
  This prevent the CD player from starting somewhere in the middle of a     
  song when you previously stopped the player at that point.                
  Please feel free to use, distribute and modify this program.              
  However, do so entirely at your own risk.                                 
  The author cannot be held responsible for any damage or loss of data,     
  caused by the use or inability to use this program.                       
  If you modify this program, please document the modifications.            
  I would also like to receive an e-mail message stating the nature of the  
  modifications.                                                            
 ͼ
*/

/* Initialize RexxUtil */
call RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
call SysLoadFuncs

/* Find full path to MMOS2's CD Player's INI files */
mmbase = value( "MMBASE", , "OS2ENVIRONMENT" )
mmbase = strip( strip( mmbase, "T", ";" ), "T", "\" )
cdpini = mmbase||"\CDP.INI"

/* Check if CDP.INI exists */
call SysFileTree cdpini, "found.", "F", , "**---"
if found.0 <> 1 then do
	call SysCls
	say ""
	call beep 880, 250
	say " ERROR: file "||cdpini||" not found."
	say ""
	exit
end

/* Find IMMCDDiscResumePosition entries and remove them */
call SysIni cdpini, "ALL:", "cdlist."
do i=1 to cdlist.0
	call SysIni cdpini, cdlist.i, "ALL:", "cdlist."i"."
	drespos = SysIni( cdpini, cdlist.i, "IMMCDDiscResumePosition" )
	if drespos <> "ERROR:" then do
		call SysIni cdpini, cdlist.i, "IMMCDDiscResumePosition", "DELETE:"
		drespos = SysIni( cdpini, cdlist.i, "IMMCDDiscResumePosition" )
		if drespos <> "ERROR:" then do
			say "["||SysIni( cdpini, cdlist.i, "IMMCDDiscTitle" )||"]"
			say "Error removing IMMCDDiscResumePosition entry"
			say ""
		end
	end
end
